/* Replace "dll.h" with the name of your header */
#include "equalizer3.h"
#include <windows.h>

DllClass::DllClass()
{

}


DllClass::~DllClass ()
{

}


BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

short equcalcul1 (equ3 * es, short in){
  // Locals
  double  l,m,h;      // Low / Mid / High - Sample Values
  float  g,sample;sample=in;

  // Filter #1 (lowpass)
  g=(es->lf)/(float)(100000.0);
  es->f1p0  += ((sample - es->f1p0+1e-9)*g);

  l = double(es->f1p0);

  // Filter #2 (highpass)
  g=(es->hf)/(float)(100000.0);
  es->f2p0  += ((sample - es->f2p0+1e-9)*g);

  h = double(sample - es->f2p0);

  // Calculate midrange (signal - (low + high))
  m = double(sample) - (h + l);

  // Scale, Combine and store
  l         *= (double(es->lowg))/(100000.0);
  m         *= (double(es->midg))/(100000.0);
  h         *= (double(es->highg))/(100000.0);


  double result;
  result=(l+m+h);
  if(result>32700.0){result=32700.0;}
  if(result<-32700.0){result=-32700.0;}
  return (short)result; 
}


short equcalcul2 (equ3 * es, short in){
  // Locals
  double  l,m,h;      // Low / Mid / High - Sample Values
  float  g,sample;sample=in;

  // Filter #1 (lowpass)
  g=(es->lf)/(float)(100000.0);
  es->f1p0  += ((sample - es->f1p0+1e-9)*g);
  es->f1p1  += ((es->f1p0 - es->f1p1)*g);

  l = double(es->f1p1);

  // Filter #2 (highpass)
  g=(es->hf)/(float)(100000.0);
  es->f2p0  += ((sample - es->f2p0+1e-9)*g);
  es->f2p1  += ((es->f2p0 - es->f2p1)*g);

  h = double(es->s1 - es->f2p1);

  // Calculate midrange (signal - (low + high))
  m = double(es->s1) - (h + l);

  // Scale, Combine and store
  l         *= (double(es->lowg))/(100000.0);
  m         *= (double(es->midg))/(100000.0);
  h         *= (double(es->highg))/(100000.0);

  // Shuffle history buffer
  es->s1   = sample;                

  double result;
  result=(l+m+h);
  if(result>32700.0){result=32700.0;}
  if(result<-32700.0){result=-32700.0;}
  return (short)result; 
}

short equcalcul3 (equ3 * es, short in){
  // Locals
  double  l,m,h;      // Low / Mid / High - Sample Values
  float  g,sample;sample=in;

  // Filter #1 (lowpass)
  g=(es->lf)/(float)(100000.0);
  es->f1p0  += ((sample - es->f1p0+1e-9)*g);
  es->f1p1  += ((es->f1p0 - es->f1p1)*g);
  es->f1p2  += ((es->f1p1 - es->f1p2)*g);

  l = double(es->f1p2);

  // Filter #2 (highpass)
  g=(es->hf)/(float)(100000.0);
  es->f2p0  += ((sample - es->f2p0+1e-9)*g);
  es->f2p1  += ((es->f2p0 - es->f2p1)*g);
  es->f2p2  += ((es->f2p1 - es->f2p2)*g);

  h = double(es->s2 - es->f2p2);

  // Calculate midrange (signal - (low + high))
  m = double(es->s2) - (h + l);

  // Scale, Combine and store
  l         *= (double(es->lowg))/(100000.0);
  m         *= (double(es->midg))/(100000.0);
  h         *= (double(es->highg))/(100000.0);

  // Shuffle history buffer
  es->s2   = es->s1;
  es->s1   = sample;                

  double result;
  result=(l+m+h);
  if(result>32700.0){result=32700.0;}
  if(result<-32700.0){result=-32700.0;}
  return (short)result; 
}

short equcalcul4 (equ3 * es, short in){
  // Locals
  double  l,m,h;      // Low / Mid / High - Sample Values
  float  g,sample;sample=in;

  // Filter #1 (lowpass)
  g=(es->lf)/(float)(100000.0);
  es->f1p0  += ((sample - es->f1p0+1e-9)*g);
  es->f1p1  += ((es->f1p0 - es->f1p1)*g);
  es->f1p2  += ((es->f1p1 - es->f1p2)*g);
  es->f1p3  += ((es->f1p2 - es->f1p3)*g);

  l = double(es->f1p3);

  // Filter #2 (highpass)
  g=(es->hf)/(float)(100000.0);
  es->f2p0  += ((sample - es->f2p0+1e-9)*g);
  es->f2p1  += ((es->f2p0 - es->f2p1)*g);
  es->f2p2  += ((es->f2p1 - es->f2p2)*g);
  es->f2p3  += ((es->f2p2 - es->f2p3)*g);

  h = double(es->s3 - es->f2p3);

  // Calculate midrange (signal - (low + high))
  m = double(es->s3) - (h + l);

  // Scale, Combine and store
  l         *= (double(es->lowg))/(100000.0);
  m         *= (double(es->midg))/(100000.0);
  h         *= (double(es->highg))/(100000.0);

  // Shuffle history buffer
  es->s3   = es->s2;
  es->s2   = es->s1;
  es->s1   = sample;                

  double result;
  result=(l+m+h);
  if(result>32700.0){result=32700.0;}
  if(result<-32700.0){result=-32700.0;}
  return (short)result; 
}


extern "C" __declspec(dllexport) long int writebuff(long int buffer,long int nmax,long int channels,equ3 * equ,equ3 * equ2,
                                                    long int typefilter)
{
 long int buff=buffer;
 long int buff2=buffer;
 long int imax=nmax;//lbuff/(2*channels);
 long int ibuff;ibuff=0;
 long int i=0;
 
 if(typefilter==1){
 if(channels==2){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul1(equ,*( short *)(buff+ibuff));
     *( short *)(buff2+ibuff+2)=equcalcul1(equ2,*( short *)(buff+ibuff+2));
     ibuff+=4;
          };
          };
 if(channels==1){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul1(equ,*( short *)(buff+ibuff));
     ibuff+=2;
          };
          };
}

 if(typefilter==2){
 if(channels==2){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul2(equ,*( short *)(buff+ibuff));
     *( short *)(buff2+ibuff+2)=equcalcul2(equ2,*( short *)(buff+ibuff+2));
     ibuff+=4;
          };
          };
 if(channels==1){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul2(equ,*( short *)(buff+ibuff));
     ibuff+=2;
          };
          };
}

 if(typefilter==3){
 if(channels==2){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul3(equ,*( short *)(buff+ibuff));
     *( short *)(buff2+ibuff+2)=equcalcul3(equ2,*( short *)(buff+ibuff+2));
     ibuff+=4;
          };
          };
 if(channels==1){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul3(equ,*( short *)(buff+ibuff));
     ibuff+=2;
          };
          };
}

 if(typefilter==4){
 if(channels==2){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul4(equ,*( short *)(buff+ibuff));
     *( short *)(buff2+ibuff+2)=equcalcul4(equ2,*( short *)(buff+ibuff+2));
     ibuff+=4;
          };
          };
 if(channels==1){
 for(i=1;i<=imax;i++){
     *( short *)(buff2+ibuff)=equcalcul4(equ,*( short *)(buff+ibuff));
     ibuff+=2;
          };
          };
}
return 0;
}


extern "C" __declspec(dllexport) long int reset(equ3 * es,equ3 * es2)
{
  es->f0p0 =1e-9;
  es->f0p1 =1e-9;
  es->f0p2 =1e-9;
  es->f0p3 =1e-9;
  es->f1p0 =1e-9;
  es->f1p1 =1e-9;
  es->f1p2 =1e-9;
  es->f1p3 =1e-9;
  es->f2p0 =1e-9;
  es->f2p1 =1e-9;
  es->f2p2 =1e-9;
  es->f2p3 =1e-9;
  es->s1 =1e-9;
  es->s2 =1e-9;
  es->s3 =1e-9;

  es2->f0p0 =1e-9;
  es2->f0p1 =1e-9;
  es2->f0p2 =1e-9;
  es2->f0p3 =1e-9;
  es2->f1p0 =1e-9;
  es2->f1p1 =1e-9;
  es2->f1p2 =1e-9;
  es2->f1p3 =1e-9;
  es2->f2p0 =1e-9;
  es2->f2p1 =1e-9;
  es2->f2p2 =1e-9;
  es2->f2p3 =1e-9;
  es2->s1 =1e-9;
  es2->s2 =1e-9;
  es2->s3 =1e-9;
  
  return 0;
}

